"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  RE_DIFF_ADD: () => RE_DIFF_ADD,
  RE_DIFF_REMOVE: () => RE_DIFF_REMOVE,
  RE_FOCUS: () => RE_FOCUS,
  RE_HIGHLIGHT: () => RE_HIGHLIGHT,
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);

// node_modules/tsup/assets/cjs_shims.js
var getImportMetaUrl = () => typeof document === "undefined" ? new URL("file:" + __filename).href : document.currentScript && document.currentScript.src || new URL("main.js", document.baseURI).href;
var importMetaUrl = /* @__PURE__ */ getImportMetaUrl();

// src/index.ts
var import_node_module = require("module");
var import_synckit = require("synckit");
var RE_HIGHLIGHT = /(?<=\/\*|#|\/\/|<%#)\s*shada:highlight\b/;
var RE_DIFF_ADD = /(?<=\/\*|#|\/\/|<%#)\s*shada:add\b/;
var RE_DIFF_REMOVE = /(?<=\/\*|#|\/\/|<%#)\s*shada:remove\b/;
var RE_FOCUS = /(?<=\/\*|#|\/\/|<%#)\s*shada:focus\b/;
function attrsLineOptions(attrs) {
  let lineNumbers = false;
  attrs.replace(/[{}]/g, "").split(",").forEach((v) => {
    const [key, value] = v.split(":");
    if (key === "lineNumbers" && (value === "true" || value === "1"))
      lineNumbers = true;
  });
  return { lineNumbers };
}
function buidLineOptions(tokens) {
  const lineOptions = [];
  let isDiff = false;
  let isFocus = false;
  for (let lineIndex = 0; lineIndex < tokens.length; lineIndex++) {
    const line = tokens[lineIndex];
    for (let tokenIndex = 0; tokenIndex < line.length; tokenIndex++) {
      const token = line[tokenIndex];
      if (RE_HIGHLIGHT.exec(token.content)) {
        lineOptions.push({
          line: lineIndex + 1,
          classes: ["line-highlight"]
        });
      }
      if (RE_DIFF_ADD.exec(token.content)) {
        lineOptions.push({
          line: lineIndex + 1,
          classes: ["line-add"]
        });
        isDiff = true;
      }
      if (RE_DIFF_REMOVE.exec(token.content)) {
        lineOptions.push({
          line: lineIndex + 1,
          classes: ["line-remove"]
        });
        isDiff = true;
      }
      if (RE_FOCUS.exec(token.content)) {
        lineOptions.push({
          line: lineIndex + 1,
          classes: ["line-focus"]
        });
        isFocus = true;
      }
    }
  }
  return { lineOptions, isDiff, isFocus };
}
var ShadaIt = (markdownit, options = {}) => {
  const _highlighter = options.highlighter;
  const themes = [];
  if (!options.theme) {
    themes.push("nord");
  } else if (typeof options.theme === "string") {
    themes.push(options.theme);
  }
  let syncRun;
  if (!_highlighter) {
    const require2 = (0, import_node_module.createRequire)(importMetaUrl);
    syncRun = (0, import_synckit.createSyncFn)(require2.resolve("./worker"));
    syncRun("getHighlighter", { themes });
  }
  const tokenizeCode = (code, lang) => {
    if (_highlighter)
      return _highlighter.codeToThemedTokens(code, lang);
    return syncRun("codeToThemedTokens", {
      code,
      lang
    });
  };
  const renderToHtml = (tokens, theme, lineOptions, attrsOptions) => {
    return syncRun("renderToHtml", {
      tokens,
      theme,
      lineOptions,
      attrsOptions
    });
  };
  markdownit.options.highlight = (code, lang = "text", attrs) => {
    const tokens = tokenizeCode(code, lang);
    const { lineOptions, isDiff, isFocus } = buidLineOptions(tokens);
    const attrsOptions = { ...attrsLineOptions(attrs), isDiff, isFocus };
    return renderToHtml(tokens, themes.at(0), lineOptions, attrsOptions);
  };
};
var src_default = ShadaIt;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  RE_DIFF_ADD,
  RE_DIFF_REMOVE,
  RE_FOCUS,
  RE_HIGHLIGHT
});
